--[[--------------------------------------------------------------------------------------------------
MAIN
------------------------------------------------------------------------------------------------------
file: extendedTimeScale
author:	[maxxer]
start project: 28.11.2021
------------------------------------------------------------------------------------------------------
Farming Simulator 22
V1.0.0.0 - 15.10.2023
------------------------------------------------------------------------------------------------------
copyright (c) [maxxer]
----------------------------------------------------------------------------------------------------]]

extendedTimeScale = {};

function extendedTimeScale:loadMap(name)
	print("-- accélération du temps (maxxer) ");
	self.isActive = false;
	self.increaseDone = false
	self.decreaseDone = false;
	self.timeScaling = {9000, 20000}
	self.increaseCount = 1;
	self.decreaseCount = -1;
end;

function extendedTimeScale:deleteMap()	
end;

function extendedTimeScale:mouseEvent(posX, posY, isDown, isUp, button)
end;

function extendedTimeScale:keyEvent(unicode, sym, modifier, isDown)
end;


function extendedTimeScale:update(dt)
	if g_currentMission.isMasterUser == true then
		if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_KP_plus) then
			if self.increaseCount <= #self.timeScaling then
				self.isActive = true;
				local timeScale = self.timeScaling[self.increaseCount];
				g_currentMission:setTimeScale(timeScale);
				self.increaseDone = true;
			end;	
		elseif self.increaseCount <=#self.timeScaling and self.increaseDone == true then	
			self.increaseDone = false;
			self.increaseCount = self.increaseCount + 1;
			self.decreaseCount = self.decreaseCount + 1;
		end;
		
		if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_KP_minus) and self.isActive == true then
			if self.decreaseCount > 0 then
				local timeScale = self.timeScaling[self.decreaseCount];
				g_currentMission:setTimeScale(timeScale);	
				self.decreaseDone = true;
			else
				if self.decreaseCount == 0 then
					self.decreaseDone = true;
				end;	
				g_currentMission:setTimeScale(120);
				self.decreaseDone = false;
				self.isActive = false;
				self.increaseCount = 1;
				self.decreaseCount = -1;
			end;	
		elseif self.decreaseCount >= 0 and self.decreaseDone == true then
			self.decreaseDone = false;
			self.increaseCount = self.decreaseCount + 1;
			self.decreaseCount = self.decreaseCount - 1;
		end;
		
		if Input.isKeyPressed(Input.KEY_8) and self.isActive == true then
			g_currentMission:setTimeScale(120);
			self.isActive = false;
			self.increaseCount = 1;
			self.decreaseCount = -1;
		end;
		
		if Input.isKeyPressed(Input.KEY_7) and self.isActive == true then
			g_currentMission:setTimeScale(1);
			self.isActive = false;
			self.increaseCount = 1;
			self.decreaseCount = -1;
		end;
	end;
end;

function extendedTimeScale:draw()      
end;

addModEventListener(extendedTimeScale);
